package com.gic.cloud.operation.web.controller;

import com.gic.api.base.commons.ServiceResponse;
import com.gic.cloud.dto.IndexGroupDTO;
import com.gic.cloud.service.IndexGroupApiService;
import com.gic.commons.webapi.reponse.RestResponse;
import com.gic.enterprise.error.ErrorCode;
import com.gic.enterprise.utils.ResultControllerUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-07-13 16:26
 */
@RestController
public class IndexGroupController {

    @Autowired
    private IndexGroupApiService indexGroupApiService;

    @RequestMapping("/saveIndexGroup")
    public RestResponse saveIndexGroup(IndexGroupDTO indexGroupDTO) {
        if (StringUtils.isBlank(indexGroupDTO.getIndexGroupName()) || indexGroupDTO.getParentId() == null) {
            return RestResponse.failure(ErrorCode.PARAMETER_ERROR.getCode(), ErrorCode.PARAMETER_ERROR.getMsg());
        }
        ServiceResponse<Void> serviceResponse = indexGroupApiService.save(indexGroupDTO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/updateIndexGroup")
    public RestResponse updateIndexGroup(IndexGroupDTO indexGroupDTO) {
        if (StringUtils.isBlank(indexGroupDTO.getIndexGroupName()) || indexGroupDTO.getParentId() == null) {
            return RestResponse.failure(ErrorCode.PARAMETER_ERROR.getCode(), ErrorCode.PARAMETER_ERROR.getMsg());
        }
        ServiceResponse<Void> serviceResponse = indexGroupApiService.update(indexGroupDTO);
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/treeIndexGroup")
    public RestResponse tree() {
        ServiceResponse<List<IndexGroupDTO>> serviceResponse = indexGroupApiService.tree();
        return ResultControllerUtils.commonResult(serviceResponse);
    }

    @RequestMapping("/deleteIndexGroup")
    public RestResponse tree(Integer indexGroupId) {
        ServiceResponse<Void> serviceResponse = indexGroupApiService.delete(indexGroupId);
        return ResultControllerUtils.commonResult(serviceResponse);
    }
}
