package com.gic.cloud.service.impl;

import com.gic.cloud.constants.LogAndUpdateTipsTypeEnum;
import com.gic.cloud.dao.mapper.TabIndexLogMapper;
import com.gic.cloud.dto.DataExplainDTO;
import com.gic.cloud.dto.IndexDTO;
import com.gic.cloud.entity.TabIndexLog;
import com.gic.cloud.service.IndexLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * @author zhiwj
 * @Description:
 * @date 2020-07-08 10:26
 */
@Service
public class IndexLogServiceImpl implements IndexLogService {

    @Autowired
    private TabIndexLogMapper tabIndexLogMapper;

    @Override
    public void saveIndexInsertLog(IndexDTO indexDTO) {
        saveLog(indexDTO, "新增");
    }

    @Override
    public void saveIndexUpdateLog(IndexDTO indexDTO, String reason) {
        saveLog(indexDTO, reason);
    }

    private void saveLog(IndexDTO indexDTO, String reason) {
        TabIndexLog indexLog = new TabIndexLog();
        indexLog.setBusinessId(indexDTO.getIndexId());
        indexLog.setOptTime(new Date());
        indexLog.setOptUserId(indexDTO.getOptUserId());
        indexLog.setOptUserName(indexDTO.getOptUserName());
        indexLog.setReason(reason);
        indexLog.setStatus(1);
        indexLog.setCreateTime(new Date());
        indexLog.setUpdateTime(new Date());
        indexLog.setType(LogAndUpdateTipsTypeEnum.INDEX.getCode());
        tabIndexLogMapper.insert(indexLog);
    }

    @Override
    public void saveDataExplainInsertLog(DataExplainDTO dataExplainDTO) {
        saveLog(dataExplainDTO, "新增");
    }

    @Override
    public void saveDataExplainUpdateLog(DataExplainDTO dataExplainDTO, String reason) {
        saveLog(dataExplainDTO, reason);
    }

    @Override
    public List<TabIndexLog> listIndexLog(Integer indexId) {
        return tabIndexLogMapper.listBusinessLog(indexId, LogAndUpdateTipsTypeEnum.INDEX.getCode());
    }

    @Override
    public List<TabIndexLog> listDataExplainLog(Integer dataExplainId) {
        return tabIndexLogMapper.listBusinessLog(dataExplainId, LogAndUpdateTipsTypeEnum.DATA_EXPLAIN.getCode());
    }

    private void saveLog(DataExplainDTO dataExplainDTO, String reason) {
        TabIndexLog indexLog = new TabIndexLog();
        indexLog.setBusinessId(dataExplainDTO.getDataExplainId());
        indexLog.setOptTime(new Date());
        indexLog.setOptUserId(dataExplainDTO.getOptUserId());
        indexLog.setOptUserName(dataExplainDTO.getOptUserName());
        indexLog.setReason(reason);
        indexLog.setStatus(1);
        indexLog.setCreateTime(new Date());
        indexLog.setUpdateTime(new Date());
        indexLog.setType(LogAndUpdateTipsTypeEnum.INDEX.getCode());
        tabIndexLogMapper.insert(indexLog);
    }
}
